codeseg segment para public 'code'
dataseg segment para public 'data'
dataseg ends
	assume cs:codeseg,ds:dataseg,es:dataseg,ss:dataseg
	extrn $begin:near
 PUBLIC flags_

flags_ proc near
 PUSH BP
 MOV BP,SP
 SUB SP,6
 MOV WORD ptr [BP-4],0
 MOV WORD ptr [BP-6],1
                     ;   MOV WORD [BP-2],0
 mov cx,8
 xor ax,ax
 mov ah,byte ptr dest_
_L1:
 shr ah,1
 adc al,0
 loop _L1
                     ;   CMP WORD [BP-2],8
                     ;   JGE _L2
                     ;   MOV AX,WORD [BP-6]
                     ;   CWD 
                     ;   MOV BX,WORD dest_[2]
                     ;   MOV CX,WORD dest_
                     ;   AND CX,AX
                     ;   AND BX,DX
                     ;   OR CX,BX
                     ;   JZ _L4
                     ;   INC WORD [BP-4]
                     ;  _L4:
                     ;   MOV AX,WORD [BP-6]
                     ;   SHL AX,1
                     ;   MOV WORD [BP-6],AX
                     ;  _L3:
                     ;   INC WORD [BP-2]
                     ;   JMP _L1
                     ;  _L2:
                     ;   MOV AX,WORD [BP-4]
                     ;   AND AX,1
                     ;   CMP AX,0
                     ;   JZ _L5
                     ;   AND WORD regs_[24],-5
                     ;   JMP _L6
                     ;  _L5:
                     ;   OR WORD regs_[24],4
 test al,1
 jz _L5
 and word ptr regs_[24],-5
 jmp _L6
_L5:
 or word ptr regs_[24],4
_L6:
 CMP WORD ptr [BP+4],1
 JNZ _L7
; MOV DX,WORD dest_[2]
; MOV AX,WORD dest_
; AND AX,255
; AND DX,0000H
; OR AX,DX
 mov al,byte ptr dest_
 or al,al
 JZ _L8
 AND WORD ptr regs_[24],-65
 JMP _L9
_L8:
 OR WORD ptr regs_[24],64
_L9:
; MOV DX,WORD dest_[2]
; MOV AX,WORD dest_
; AND AX,128
; AND DX,0000H
; OR AX,DX
 test byte ptr dest_,128
 JZ _L10
 OR WORD ptr regs_[24],128
 JMP _L12
_L10:
 AND WORD ptr regs_[24],-129
_L11:
 JMP _L12
_L7:
; MOV DX,WORD dest_[2]
; MOV AX,WORD dest_
; AND AX,-1
; AND DX,0000H
; OR AX,DX
 test word ptr dest_,-1
 JZ _L13
 AND WORD ptr regs_[24],-65
 JMP _L14
_L13:
 OR WORD ptr regs_[24],64
_L14:
; MOV DX,WORD dest_[2]
; MOV AX,WORD dest_
; AND AX,-32768
; AND DX,0000H
; OR AX,DX
 test word ptr dest_,-32768
 JZ _L15
 OR WORD ptr regs_[24],128
 JMP _L16
_L15:
 AND WORD ptr regs_[24],-129
_L16:
_L12:
 MOV SP,BP
 POP BP
 RET
flags_ endp

 PUBLIC ovcarry_

ovcarry_ proc near
 PUSH BP
 MOV BP,SP
 push si
 push di
 mov bx,word ptr dest_[4]   ;low word of dest.oldvalue
 mov si,word ptr [bp+6]     ;get carryvalue
 mov ax,word ptr [bp+4]     ;get value
 mov cx,0               ;cl=ovflag, ch=cyflag
 cmp word ptr [bp+8],1      ;byte?
 jne ovcyword           ;no, go do word
 mov ah,0               ;only need byte value
 mov dx,ax              ;save for later
 mov bh,ah              ;and dest.oldvalue,0ffh
 add ax,bx              ;(value&0xff) + (dest.oldvalue&0xff)
 add ax,si              ;+carryvalue
 cmp ah,0               ;carry out?
 je nbcy                ;no byte carry
 mov ch,1               ;set cyflag
 or word ptr regs_[24],1    ;set carry
 jmp chkbov
nbcy:
 mov ch,0               ;clear cyflag
 and word ptr regs_[24],-2  ;clear carry
chkbov:
 mov ax,dx              ;get value back
 and al,07fh            ;and value,07fh
 and bl,07fh            ;and dest.oldvalue,07fh
 add ax,bx              ;(value&0x7f) + (dest.oldvalue&0x7f)
 add ax,si              ;+carryvalue
 test al,80h            ;carry into sign?
 jz nbsc                ;no byte sign carry
 mov cl,1               ;set ovflag
 jmp chkbac
nbsc:
 mov cl,0               ;clear ovflag
chkbac:
 mov ax,dx              ;restore value
 and al,0fh             ;and value,0fh
 and bl,0fh             ;and dest.oldvlaue,0fh
 add ax,bx              ;(value&0x0f) + (dest.oldvalue&0x0f)
 add ax,si              ;+carryvalue
 test al,10h            ;aux carry?
 jz nbac                ;no byte aux carry
 or word ptr regs_[24],16   ;set auxcarry
 jmp tstbov
nbac:
 and word ptr regs_[24],-17 ;clear auxcarry 
tstbov:
 cmp ch,cl              ;is ovflag == cyflag?
 jne setbov             ;no, set overflow
 and word ptr regs_[24],-2049   ;clear OV
 jmp ovcyend
setbov:
 or word ptr regs_[24],2048     ;set OV
 jmp ovcyend
ovcyword:
 mov dx,ax              ;save value in dx
 mov di,0               ;start with high word at 0
 add ax,bx              ;(value & 0xffff) + (dest.oldvalue&0xffff)
 adc di,0               ;+carry into high word
 add ax,si              ;+carryvalue
 adc di,0               ;+carry into high word
 jz nwcy                ;no word carry
 mov ch,1               ;set cyflag
 or word ptr regs_[24],1    ;set carry
 jmp chkwov
nwcy:
 mov ch,0               ;clear cyflag
 and word ptr regs_[24],-2  ;clear carry
chkwov:
 mov ax,dx              ;get back value
 and ah,7fh             ;value & 0x7fff
 and bh,7fh             ;dest.oldvalue & 0x7fff
 add ax,bx              ;(value&0x7fff) + (dest.oldvalue&0x7fff)
 add ax,si              ;+carryvalue
 test ah,80h            ;carry into sign?
 jz nwsc                ;no word sign carry
 mov cl,1               ;set ovflag
 jmp chkwac
nwsc:
 mov cl,0               ;clear ovflag
chkwac:
 mov ax,dx              ;get back value
 and ax,000fh           ;mask to nibble
 and bx,000fh           ;mask to nibble
 add ax,bx              ;(value&0x0f) + (dest.oldvalue & 0x0f)
 add ax,si              ;+carryvalue
 test al,10h            ;aux carry?
 jz nwac                ;no word aux carry
 or word ptr regs_[24],16   ;set auxcarry
 jmp tstwov
nwac:
 and word ptr regs_[24],-17 ;clear AC
tstwov:
 cmp ch,cl              ;is cyflag == ovflag?
 jne setwov             ;no, set overflow
 and word ptr regs_[24],-2049    ;clear overflow
 jmp ovcyend
setwov:
 or word ptr regs_[24],2048      ;set overflow
ovcyend:
 pop di
 pop si
 POP BP
 RET
ovcarry_ endp

	public checkaddress1_
checkaddress1_ proc	near
	push bp
	mov bp,sp
ifdef $52
	add sp,$52
endif
ifdef	$53
	push	di
endif
ifdef $54
	push	si
endif
	mov	bx,word ptr 6[bp]
	mov	ax, word ptr  [bx]
	mov	cx,4
	shr	ax,cl
	mov	bx,word ptr 4[bp]
	add	ax, word ptr  [bx]
	mov	word ptr -6[bp],ax
	mov	cx,12
	shr	ax,cl
	mov	word ptr -8[bp],ax
	cmp	 word ptr numbreaks_,0
	beq 	$55
	mov	ax,word ptr -6[bp]
	sub dx,dx
	mov cx,4
$56:
	shl	ax,1
	rcl	dx,1
	loop	$56
	mov	bx,dx
	mov	cx,ax
	mov	si,word ptr 6[bp]
	mov	ax, word ptr  [si]
	and	ax,15
	sub dx,dx
	add	cx,ax
	adc	bx,dx
	mov	dx,bx
	mov	ax,cx
	mov	word ptr -2[bp],dx
	mov word ptr -4[bp],ax
	mov	word ptr -10[bp],1
$59:
	mov	ax,word ptr -10[bp]
	cmp	ax, word ptr numbreaks_
	bhi 	$58
	shl	ax,1
	shl	ax,1
	shl	ax,1
	mov	bx,ax
	mov	dx,word ptr -2[bp]
	mov	ax,word ptr -4[bp]
	cmp	dx,word ptr brkpoints_+2 [bx]
	jl  	$61
	jne	$62
	cmp	ax,word ptr brkpoints_ [bx]
	jae 	$63
$61:
	jmp $60
$62:
$63:
	cmp	dx,word ptr brkpoints_+6 [bx]
	jg  	$64
	jne	$65
	cmp	ax,word ptr brkpoints_+4 [bx]
	jbe 	$66
$64:
	jmp $60
$65:
$66:
	mov	bx,word ptr -10[bp]
	shl	bx,1
	dec	word ptr brkcounts_ [bx]
	bne 	$67
	mov	 word ptr memok_,0
$67:
$60:
$57:
	inc	word ptr -10[bp]
	jmp $59
$58:
$55:
	mov	bx,word ptr -8[bp]
	shl	bx,1
	mov	ax,word ptr memmap_ [bx]
	mov	bx,word ptr 4[bp]
	add	 word ptr  [bx],ax
$68:
ifdef $54
	pop si
endif
ifdef	$53
	pop	di
endif
	mov	sp,bp
	pop	bp
	ret
$52 = -10
$54	equ 1
checkaddress1_ endp
	public checkwaddress1_
checkwaddress1_ proc	near
	push bp
	mov bp,sp
ifdef $69
	add sp,$69
endif
ifdef	$70
	push	di
endif
ifdef $71
	push	si
endif
	mov	bx,word ptr 6[bp]
	mov	ax, word ptr  [bx]
	mov	cx,4
	shr	ax,cl
	mov	bx,word ptr 4[bp]
	add	ax, word ptr  [bx]
	mov	word ptr -10[bp],ax
	mov	cx,12
	shr	ax,cl
	mov	word ptr -14[bp],ax
	push	cx
	mov	bx,word ptr 10[bp]
	mov	ax, word ptr  [bx]
	mov	cx,4
	shr	ax,cl
	mov	bx,word ptr 8[bp]
	add	ax, word ptr  [bx]
	mov	word ptr -12[bp],ax
	pop	cx
	shr	ax,cl
	mov	word ptr -16[bp],ax
	cmp	 word ptr numbreaks_,0
	beq 	$72
	mov	ax,word ptr -10[bp]
	sub dx,dx
	mov cx,4
$73:
	shl	ax,1
	rcl	dx,1
	loop	$73
	mov	bx,dx
	mov	cx,ax
	mov	si,word ptr 6[bp]
	mov	ax, word ptr  [si]
	and	ax,15
	sub dx,dx
	add	cx,ax
	adc	bx,dx
	mov	dx,bx
	mov	ax,cx
	mov	word ptr -2[bp],dx
	mov word ptr -4[bp],ax
	mov	ax,word ptr -12[bp]
	sub dx,dx
	mov	di,dx
	mov	si,ax
	mov cx,4
$74:
	shl	si,1
	rcl	di,1
	loop	$74
	mov	bx,word ptr 10[bp]
	mov	ax, word ptr  [bx]
	and	ax,15
	sub dx,dx
	add	si,ax
	adc	di,dx
	mov	dx,di
	mov	ax,si
	mov	word ptr -6[bp],dx
	mov word ptr -8[bp],ax
	mov	word ptr -18[bp],1
$77:
	mov	ax,word ptr -18[bp]
	cmp	ax, word ptr numbreaks_
	bhi 	$76
	shl	ax,1
	shl	ax,1
	shl	ax,1
	mov	bx,ax
	mov	dx,word ptr -2[bp]
	mov	ax,word ptr -4[bp]
	cmp	dx,word ptr brkpoints_+2 [bx]
	jl  	$79
	jne	$80
	cmp	ax,word ptr brkpoints_ [bx]
	jae 	$81
$79:
	jmp $78
$80:
$81:
	cmp	dx,word ptr brkpoints_+6 [bx]
	jg  	$82
	jne	$83
	cmp	ax,word ptr brkpoints_+4 [bx]
	jbe 	$84
$82:
	jmp $78
$83:
$84:
	mov	bx,word ptr -18[bp]
	shl	bx,1
	dec	word ptr brkcounts_ [bx]
	bne 	$85
	mov	 word ptr memok_,0
$85:
$78:
	mov	bx,word ptr -18[bp]
	shl	bx,1
	shl	bx,1
	shl	bx,1
	mov	dx,word ptr -6[bp]
	mov	ax,word ptr -8[bp]
	cmp	dx,word ptr brkpoints_+2 [bx]
	jl  	$87
	jne	$88
	cmp	ax,word ptr brkpoints_ [bx]
	jae 	$89
$87:
	jmp $86
$88:
$89:
	cmp	dx,word ptr brkpoints_+6 [bx]
	jg  	$90
	jne	$91
	cmp	ax,word ptr brkpoints_+4 [bx]
	jbe 	$92
$90:
	jmp $86
$91:
$92:
	mov	bx,word ptr -18[bp]
	shl	bx,1
	dec	word ptr brkcounts_ [bx]
	bne 	$93
	mov	 word ptr memok_,0
$93:
$86:
$75:
	inc	word ptr -18[bp]
	jmp $77
$76:
$72:
	mov	bx,word ptr -14[bp]
	shl	bx,1
	mov	ax,word ptr memmap_ [bx]
	mov	bx,word ptr 4[bp]
	add	 word ptr  [bx],ax
	mov	bx,word ptr -16[bp]
	shl	bx,1
	mov	ax,word ptr memmap_ [bx]
	mov	bx,word ptr 8[bp]
	add	 word ptr  [bx],ax
$94:
ifdef $71
	pop si
endif
ifdef	$70
	pop	di
endif
	mov	sp,bp
	pop	bp
	ret
$69 = -18
$71	equ 1
$70	equ 1
checkwaddress1_ endp
codeseg	ends
dataseg segment para public 'data'
	extrn	memmap_:word
	extrn	numbreaks_:word
	extrn	memok_:word
	extrn	brkcounts_:word
	extrn	brkpoints_:word
	extrn	dest_:word
	extrn	regs_:word
dataseg ends
	end
