/* Copyright (C) 1981,1982 by Manx Software Systems */

/*
   Modified 9/2/1987 by William Couture, to support internal re-direction
   within VIM.  Modifications copyright (c) 1988 by William Couture.
*/

#include "include\stdio.h"

char *mygets2(line)
char *line;
{
	register char *cp;
	register int i;

	cp = line;
	while ((i = myagetc(stdin)) != EOF && i != '\n')
		*cp++ = i;
	*cp = 0;
	if (i == EOF && cp == line)
		return NULL;
	return line;
}

myagetc(ptr)
register FILE *ptr;
{
	register int c;

top:
	if ((c = mygetc(ptr)) != EOF) {
		switch (c &= 127) {
		case 0x1a:
			return EOF;
		case '\r':
		case 0:
			goto top;
		}
	}
	return c;
}

mygetc(ptr)
register FILE *ptr;
{
	register int len;

	if (ptr->_bp >= ptr->_bend) {
		if (ptr->_flags&(_EOF|_IOERR))
			return EOF;
		ptr->_flags &= ~_DIRTY;
		if (ptr->_buff == NULL)
			getbuff(ptr);
		if ((len = read(ptr->_unit,ptr->_buff,ptr->_buflen)) <= 0) {
			ptr->_flags |= len==0 ? _BUSY : _IOERR;
			return EOF;
		}
		ptr->_bend = (ptr->_bp = ptr->_buff) + len;
	}
	return *ptr->_bp++ & 255;
}
