set cctemp=c:
rem set include=c:\aztec

as -S4 decodens.azt
if errorlevel 1 goto oops
as peek.azt
if errorlevel 1 goto oops
as -S4 asmfns.azt
if errorlevel 1 goto oops
as inthdlrs.azt
if errorlevel 1 goto oops

cc -n -z16000 help
if errorlevel 1 goto oops
cc -n -a dosfns
if errorlevel 1 goto oops
cc -n optables
if errorlevel 1 goto oops
cc -n opnames
if errorlevel 1 goto oops
cc -n asmtable
if errorlevel 1 goto oops
cc -n decode
if errorlevel 1 goto oops
cc -n fns
if errorlevel 1 goto oops
cc -n morefns
if errorlevel 1 goto oops
cc -n vim
if errorlevel 1 goto oops
cc -n -a morevim
if errorlevel 1 goto oops
cc -n dump
if errorlevel 1 goto oops
cc -n vimasm
if errorlevel 1 goto oops

ln -T -F vimlinks
fixvim

pause

@echo off

echo  For DOSFNS and MOREVIM, there are references to externals which appear
echo  only in the in-line assembly, and so Aztec throws away the C extern
echo  declarations.
echo.
echo  Assemble (AS filename) the programs, note the errors, edit the .ASM
echo  files to include the appropriate extrn declarations (at the end of the
echo  file, the DOSFNS.BUF and MOREVIM.BUF files contain the appropriate
echo  declarations), and re-assemble them with the following statements
echo.
echo  as -s4 dosfns
echo  as -s4 morevim
echo.
echo  Then, you can re-run the
echo      ln -T -F vimlinks
echo  and
echo      fixvim
echo  commands
echo.
echo  When transferring in-line assembly between DeSemt and Aztec C, make sure
echo  that all WORD [xxxx] and BYTE [xxxx] references are changed to
echo  WORD PTR [xxxx] and BYTE PTR [xxxx]
echo  Also, note that Aztec C requires you to hand generate the C preifx and
echo  suffix code if the function contains ONLY inline assembly!

pause

:oops
